{"revision":"c10276e953456835cdbb1f3a60d58ae1980be353","document":{"id":1022,"path":"api-reference/server-api-reference/c_GlideRecordAPI.md","title":"GlideRecord - Global","bundle":null,"doc_type":null,"release":"australia","body":"\n# GlideRecord- Global\n\nThe GlideRecord API is used for database operations.\n\nThe GlideRecord API is the primary means of interfacing with the database on the server-side code. A GlideRecord is an object that contains records from a single table. Use the API to instantiate a GlideRecord object and add query parameters, filters, limits, and ordering.\n\nTo use this API to create dynamic attributes you must have the dynamic\\_schema\\_writer role. To read dynamic data using this API you must have the dynamic\\_schema\\_reader role.\n\nFor information on a class that performs the same functions as GlideRecord and enforces ACLs, see [Using GlideRecordSecure](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/scripts/p_GlideServerAPIs.md).\n\nSee also [Dynamic Schema](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/platform-administration/dynamic-schema.md).\n\nSee the [GlideRecord](https://developer.servicenow.com/dev.do#!/learn/courses/utah/app_store_learnv2_scripting_utah_scripting_in_servicenow/app_store_learnv2_scripting_utah_server_side_scripting/app_store_learnv2_scripting_utah_gliderecord) article for details on building and running queries.\n\nFor information about GlideRecordSecure, which is a class inherited from GlideRecord that performs the same functions as GlideRecord and also enforces ACLs, see the [GlideServer APIs](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/scripts/p_GlideServerAPIs.md).\n\nAlways test queries on a sub-production instance prior to deploying them on a production instance. An incorrectly constructed encoded query, such as including an invalid field name, produces an invalid query. When the invalid query is run, the invalid part of the query condition is dropped, and the results are based on the valid part of the query, which may return all records from the table. Using an insert\\(\\), update\\(\\), deleteRecord\\(\\), or deleteMultiple\\(\\) method on bad query results can result in data loss.\n\nYou can set the **glide.invalid\\_query.returns\\_no\\_rows** system property to true to have queries with invalid encoded queries return no records. In some cases, the query may still return records in API results even when **glide.invalid\\_query.returns\\_no\\_rows** is set to true. This happens in queries where an invalid query term is used with a WHERE operator. In such queries, the WHERE operator ignores the invalid term\\(s\\) but still interprets and returns the rest of the query statement. For more information about this system property and its functionality, see [Available system properties](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/platform-administration/r_AvailableSystemProperties.md).\n\n## Retrieve values from records\n\nIn most cases, don’t use dot-walking to get values from a record. Dot-walking retrieves the entire object instead of the field value. Retrieving the object uses more storage and might cause undesirable results when used in arrays or in Service Portal.\n\nInstead of retrieving the entire object, you can use one of the following methods to copy the field values:\n\n-   [getValue\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md)\n-   [getDisplayValue\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md)\n\nIf dot-walking through a GlideElement object is necessary, use the toString\\(\\) method to retrieve values. For example, you might need the current caller's manager sys\\_id to set another reference field. The following example shows how to get the string value instead of the entire object:\n\n```\nvar mgr = current.caller_id.manager.toString();\n```\n\n## Dynamic attributes\n\nThere are methods in this API that have the same functionality as dynamic schema methods in the [GlideDynamicAttributeStore - Global](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/GlideDynamicAttStoreAPI.md) API. Use the dynamic attribute methods in this API to perform actions on a specified GlideRecord. Use the methods in the GlideDynamicAttributeStore API if you want to set the same group of dynamic attributes on multiple records. Using this API, you can stage a GlideDynamicAttributeStore object with the desired attributes and then copy that object to multiple GlideRecords using the various setDynamicAttributeValues\\(\\) methods.\n\nSee also:\n\n-   [GlideAggregate](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideAggregateAPI.md)\n-   [GlideElement](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideElementAPI.md)\n-   [GlideQuery](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/GlideQueryGlobalAPI.md)\n\n**Parent Topic:**[Server API reference](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/api-server.md)\n\n## GlideRecord - GlideRecord\\(String tableName\\)\n\nCreates an instance of the GlideRecord class for the specified table.\n\n|Name|Type|Description|\n|----|----|-----------|\n|tableName|String|Table to use.|\n\n```\nvar now_GR = new GlideRecord('incident');\n```\n\n## GlideRecord - addActiveQuery\\(\\)\n\nAdds a filter to return active records.\n\n|Name|Type|Description|\n|----|----|-----------|\n|None| | |\n\n|Type|Description|\n|----|-----------|\n|GlideQueryCondition|Filter to return active records.|\n\n```\nvar inc = new GlideRecord('incident');\ninc.addActiveQuery();\ninc.query();\n```\n\n### Scoped equivalent\n\nTo use the addActiveQuery\\(\\) method in a scoped application, use the corresponding scoped method: [addActiveQuery\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordScopedAPI.md).\n\n## GlideRecord - addDomainQuery\\(Object glideRecord\\)\n\nChanges the domain used for the query from the user's domain to the domain of the provided GlideRecord.\n\nAlways test queries on a sub-production instance prior to deploying them on a production instance. An incorrectly constructed encoded query, such as including an invalid field name, produces an invalid query. When the invalid query is run, the invalid part of the query condition is dropped, and the results are based on the valid part of the query, which may return all records from the table. Using an insert\\(\\), update\\(\\), deleteRecord\\(\\), or deleteMultiple\\(\\) method on bad query results can result in data loss.\n\nYou can set the **glide.invalid\\_query.returns\\_no\\_rows** system property to true to have queries with invalid encoded queries return no records. In some cases, the query may still return records in API results even when **glide.invalid\\_query.returns\\_no\\_rows** is set to true. This happens in queries where an invalid query term is used with a WHERE operator. In such queries, the WHERE operator ignores the invalid term\\(s\\) but still interprets and returns the rest of the query statement. For more information about this system property and its functionality, see [Available system properties](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/platform-administration/r_AvailableSystemProperties.md).\n\nThis function requires the Domain Support - Domain Extensions Installer \\(com.glide.domain.msp\\_extensions.installer\\) plugin.\n\n|Name|Type|Description|\n|----|----|-----------|\n|glideRecord|Object|GlideRecord from which to obtain the domain.|\n\n|Type|Description|\n|----|-----------|\n|void| |\n\n```\n//This example requires the Domain plugin be active, the Group table is the specified \n//Domain table, and the ITIL user is in the Database Atlanta domain\n//From any domain (using queryNoDomain()) look up the incidents that an ITIL user can only see \n//who is in the Database Atlanta domain, should expect all incidents with the global or the\n//Database Atlanta domain specified.\nvar domain = new GlideRecord('sys_user');\ndomain.addQuery('user_name', 'itil');\ndomain.queryNoDomain();\nif (domain.next()) {\n    var domainQuery = new GlideRecord('incident');\n    domainQuery.addQuery('active', true);\n    domainQuery.addDomainQuery(domain);\n    domainQuery.query();\n    gs.print('Number of Incidents for ITIL user: ' + domainQuery.getRowCount());\n    while (domainQuery.next())\n        gs.print(domainQuery.number);\n}\n```\n\n### Scoped equivalent\n\nThis method is not available in scoped applications.\n\n## GlideRecord - addEncodedQuery\\(String query, Boolean enforceFieldACL\\)\n\nAdds an encoded query to other queries that may have been set.\n\nAlways test queries on a sub-production instance prior to deploying them on a production instance. An incorrectly constructed encoded query, such as including an invalid field name, produces an invalid query. When the invalid query is run, the invalid part of the query condition is dropped, and the results are based on the valid part of the query, which may return all records from the table. Using an insert\\(\\), update\\(\\), deleteRecord\\(\\), or deleteMultiple\\(\\) method on bad query results can result in data loss.\n\nYou can set the **glide.invalid\\_query.returns\\_no\\_rows** system property to true to have queries with invalid encoded queries return no records. In some cases, the query may still return records in API results even when **glide.invalid\\_query.returns\\_no\\_rows** is set to true. This happens in queries where an invalid query term is used with a WHERE operator. In such queries, the WHERE operator ignores the invalid term\\(s\\) but still interprets and returns the rest of the query statement. For more information about this system property and its functionality, see [Available system properties](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/platform-administration/r_AvailableSystemProperties.md).\n\n**Note:** To enforce query access based on the user, use[addUserEncodedQuery\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md).\n\n<table id=\"table_j3p_mlp_dt\" class=\"parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nType\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nquery\n\n</td><td>\n\nString\n\n</td><td>\n\nAn [encoded query string](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/platform-user-interface/c_EncodedQueryStrings.md).\n\n</td></tr><tr><td>\n\nenforceFieldACL\n\n</td><td>\n\nBoolean\n\n</td><td>\n\nOptional. Flag that indicates whether to enforce field ACL \\(Access Control List\\) rules.Valid values:\n\n-   true: Enforce field ACLs.\n-   false: Don't enforce field ACLs.\n\nDefault: false\n\n</td></tr></tbody>\n</table>|Type|Description|\n|----|-----------|\n|void| |\n\n```\nvar queryString = \"priority=1^ORpriority=2\";\n var now_GR = new GlideRecord('incident');\n \n now_GR.addEncodedQuery(queryString);\n now_GR.query();\n while (now_GR.next()) {\n gs.addInfoMessage(now_GR.number);\n }\n```\n\n### Scoped equivalent\n\nTo use the addEncodedQuery\\(\\) method in a scoped application, use the corresponding scoped method: [addEncodedQuery\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordScopedAPI.md).\n\n## GlideRecord - addExtraField\\(String dotWalkedField\\)\n\nQueries one or more dot-walked fields from a form or script in a single request.\n\nThe addExtraField\\(\\) method allows you to query dot-walked fields in a single database request, rather than perform multiple queries per dot-walked element in a form or script \\(which requires multiple round trips to the database\\).\n\n<table id=\"table_ctk_qcx_hzb\" class=\"parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nType\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\ndotWalkedField\n\n</td><td>\n\nString\n\n</td><td>\n\nThe dot-walked field name. Levels of field names are separated by dots \\(periods\\). For example, enter the value `Caller.Company` if you want to query the **Company** &gt; **Caller** condition in the Incident \\[incident\\] table.The format of **dotWalkedField** follows the left-to-right order of fields in a dotwalked form or script.\n\n</td></tr></tbody>\n</table><table id=\"table_dtk_qcx_hzb\" class=\"returns\"><thead><tr><th>\n\nType\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nNone\n\n</td><td>\n\n**Note:** The addExtraField\\(\\) method does not impact output results; the output is always the same regardless if you use this method in your script.\n\n</td></tr></tbody>\n</table>The following example shows how to query the contact name field of cmn\\_location \\(referenced from the “location” reference field in a cmdb\\_ci field\\).\n\n**Note:** The dotWalkedField value in this example, `cmdb_ci.location.contact.name`, looks like “cmdb\\_ci fields” =&gt; “cmn\\_location fields” =&gt; “sys\\_user fields” in the ServiceNow® UI when selecting fields in a list.\n\n```\nvar gliderecord = new GlideRecord(\"incident\");\ngliderecord.addQuery(\"number\", \"INC0041457\");\ngliderecord.addExtraField(\"cmdb_ci.location.contact.name\");\ngliderecord.query();\ngliderecord.next();\ngs.print(gliderecord.cmdb_ci.location.contact.name);\n```\n\nThe output is the same as `gs.print(gr.cmdb_ci.location.contact.name)` without using addExtraField\\(\\). The addExtraField\\(\\) method optimizes the querying of the dot-walked fields. Example output:\n\n```\nAbel Tuter\n```\n\n## GlideRecord - addFunction\\(Object function\\)\n\nApplies a pre-defined GlideDBFunctionBuilder object to a record.\n\nUse the GlideDBFunctionBuilder scoped class to define a function. After the function is defined, use the addFunction\\(Object function\\) method to apply the function to a record.\n\n|Name|Type|Description|\n|----|----|-----------|\n|function|Object|A GlideDBFunctionBuilder or GlideDBCaseStatementBuilder object that defines a SQL operation.|\n\n|Type|Description|\n|----|-----------|\n|void| |\n\n```\nvar functionBuilder = new GlideDBFunctionBuilder();\nvar myAddingFunction = functionBuilder.add();\nmyAddingFunction = functionBuilder.field('order');\nmyAddingFunction = functionBuilder.field('priority');\nmyAddingFunction = functionBuilder.build();\n\nvar now_GR = new GlideRecord('incident');\nnow_GR.addFunction(myAddingFunction);\nnow_GR.addQuery(myAddingFunction, '<', 5);\nnow_GR.query();\nwhile(now_GR.next())\ngs.log(now_GR.getValue(myAddingFunction));\n\n```\n\nOutput:\n\n```\n*** Script: 1\n*** Script: 4\n*** Script: 3\n*** Script: 1\n*** Script: 1\n*** Script: 2\n*** Script: 1\n*** Script: 1\n```\n\n## GlideRecord - addInactiveQuery\\(\\)\n\nAdds a filter to return inactive records. Inactive records have the active flag set to false.\n\n|Name|Type|Description|\n|----|----|-----------|\n|None| | |\n\n|Type|Description|\n|----|-----------|\n|GlideQueryCondition|Records where the active flag is false.|\n\n```\nvar inc = new GlideRecord('incident');\ninc.addInactiveQuery();\ninc.query();\n```\n\n### Scoped equivalent\n\nIn scoped applications use the scoped method [addQuery\\(\"active\",\"false\"\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordScopedAPI.md).\n\n## GlideRecord - addJoinQuery\\(String table\\)\n\nAdds a filter to return records based on a relationship in a related table.\n\nFor example, find all the users that are in the database group \\(users via sys\\_user\\_grmember table\\). Another example would be find all problems that have an assigned incident \\(problems via the incident.problem\\_id relationship\\).\n\nThis is not a true database join; rather, addJoinQuery\\(\\) adds a subquery. So, while the result set is limited based on the join, the only fields that you have access to are those on the base table \\(those which are in the table with which the GlideRecord was initialized\\).\n\nAlways test queries on a sub-production instance prior to deploying them on a production instance. An incorrectly constructed encoded query, such as including an invalid field name, produces an invalid query. When the invalid query is run, the invalid part of the query condition is dropped, and the results are based on the valid part of the query, which may return all records from the table. Using an insert\\(\\), update\\(\\), deleteRecord\\(\\), or deleteMultiple\\(\\) method on bad query results can result in data loss.\n\nYou can set the **glide.invalid\\_query.returns\\_no\\_rows** system property to true to have queries with invalid encoded queries return no records. In some cases, the query may still return records in API results even when **glide.invalid\\_query.returns\\_no\\_rows** is set to true. This happens in queries where an invalid query term is used with a WHERE operator. In such queries, the WHERE operator ignores the invalid term\\(s\\) but still interprets and returns the rest of the query statement. For more information about this system property and its functionality, see [Available system properties](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/platform-administration/r_AvailableSystemProperties.md).\n\n|Name|Type|Description|\n|----|----|-----------|\n|table|String|Table name|\n\n|Type|Description|\n|----|-----------|\n|GlideQueryCondition|Records where the relationships match.|\n\nFind problems that have an incident attached. This example returns problems that have associated incidents. However, it won't pull values from the incidents that are returned as a part of the query.\n\n```\nvar prob = new GlideRecord('problem');\nprob.addJoinQuery('incident');\nprob.query();\n```\n\nFind active=false problems with associated incidents.\n\n```\n// Look for Problem records\nvar now_GR = new GlideRecord('problem');\n \n// That have associated Incident records\nvar grSQ = now_GR.addJoinQuery('incident');\n \n// Where the Problem records are \"active=false\"\nnow_GR.addQuery('active', 'false');\n \n// And the Incident records are \"active=true\"\ngrSQ.addCondition('active', 'true');\n \n// Query\nnow_GR.query();\n \n// Iterate and print results\nwhile (now_GR.next()) {\n    gs.print(now_GR.getValue('number'));\n}\n```\n\n### Scoped equivalent\n\nTo use the addJoinQuery\\(\\) method in a scoped application, use the corresponding scoped method: [addJoinQuery\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordScopedAPI.md).\n\n## GlideRecord - addJoinQuery\\(String table, String primaryField\\)\n\nAdds a filter to return records based on a relationship in a related table.\n\nFor example, find all the users that are in the database group \\(users via sys\\_user\\_grmember table\\). Another example would be find all problems that have an assigned incident \\(problems via the incident.problem\\_id relationship\\).\n\nThis is not a true database join; rather, addJoinQuery\\(\\) adds a subquery. So, while the result set is limited based on the join, the only fields that you have access to are those on the base table \\(those which are in the table with which the GlideRecord was initialized\\).\n\nAlways test queries on a sub-production instance prior to deploying them on a production instance. An incorrectly constructed encoded query, such as including an invalid field name, produces an invalid query. When the invalid query is run, the invalid part of the query condition is dropped, and the results are based on the valid part of the query, which may return all records from the table. Using an insert\\(\\), update\\(\\), deleteRecord\\(\\), or deleteMultiple\\(\\) method on bad query results can result in data loss.\n\nYou can set the **glide.invalid\\_query.returns\\_no\\_rows** system property to true to have queries with invalid encoded queries return no records. In some cases, the query may still return records in API results even when **glide.invalid\\_query.returns\\_no\\_rows** is set to true. This happens in queries where an invalid query term is used with a WHERE operator. In such queries, the WHERE operator ignores the invalid term\\(s\\) but still interprets and returns the rest of the query statement. For more information about this system property and its functionality, see [Available system properties](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/platform-administration/r_AvailableSystemProperties.md).\n\n|Name|Type|Description|\n|----|----|-----------|\n|table|String|Table name|\n|primaryField|String|If other than sys\\_id, the primary field.|\n\n|Type|Description|\n|----|-----------|\n|GlideQueryCondition|Records where the relationships match.|\n\nFind problems that have incidents using the open\\_by field at the join key instead of the sys\\_id.\n\n```\nvar now_GR = new GlideRecord('problem'); \nnow_GR.addJoinQuery('incident', 'opened_by'); \nnow_GR.query();\n```\n\n### Scoped equivalent\n\nTo use the addJoinQuery\\(\\) method in a scoped application, use the corresponding scoped method: [addJoinQuery\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordScopedAPI.md).\n\n## GlideRecord - addJoinQuery\\(String table, String primaryField, String joinTableField\\)\n\nAdds a filter to return records based on a relationship in a related table.\n\nFor example, find all the users that are in the database group \\(users via sys\\_user\\_grmember table\\). Another example would be find all problems that have an assigned incident \\(problems via the incident.problem\\_id relationship\\).\n\nThis is not a true database join; rather, addJoinQuery\\(\\) adds a subquery. So, while the result set is limited based on the join, the only fields that you have access to are those on the base table \\(those which are in the table with which the GlideRecord was initialized\\).\n\nAlways test queries on a sub-production instance prior to deploying them on a production instance. An incorrectly constructed encoded query, such as including an invalid field name, produces an invalid query. When the invalid query is run, the invalid part of the query condition is dropped, and the results are based on the valid part of the query, which may return all records from the table. Using an insert\\(\\), update\\(\\), deleteRecord\\(\\), or deleteMultiple\\(\\) method on bad query results can result in data loss.\n\nYou can set the **glide.invalid\\_query.returns\\_no\\_rows** system property to true to have queries with invalid encoded queries return no records. In some cases, the query may still return records in API results even when **glide.invalid\\_query.returns\\_no\\_rows** is set to true. This happens in queries where an invalid query term is used with a WHERE operator. In such queries, the WHERE operator ignores the invalid term\\(s\\) but still interprets and returns the rest of the query statement. For more information about this system property and its functionality, see [Available system properties](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/platform-administration/r_AvailableSystemProperties.md).\n\n|Name|Type|Description|\n|----|----|-----------|\n|table|String|Table name|\n|primaryField|String|If other than sys\\_id, the primary field.|\n|joinTableField|String|If other than sys\\_id, the field that joins the tables|\n\n|Type|Description|\n|----|-----------|\n|GlideQueryCondition|Records where the relationships match.|\n\nFind problems that have incidents associated where the incident caller\\_id field value matches that of the problem opened\\_by field.\n\n```\nvar now_GR = new GlideRecord('problem'); \nnow_GR.addJoinQuery('incident', 'opened_by', 'caller_id'); \nnow_GR.query();\n```\n\n### Scoped equivalent\n\nTo use the addJoinQuery\\(\\) method in a scoped application, use the corresponding scoped method: [addJoinQuery\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordScopedAPI.md).\n\n## GlideRecord - addNotNullQuery\\(String fieldName\\)\n\nAdds a filter to return records where the specified field is not null.\n\n|Name|Type|Description|\n|----|----|-----------|\n|fieldName|String|The field name.|\n\n|Type|Description|\n|----|-----------|\n|GlideQueryCondition|GlideQueryCondition of records where the parameter field is not null.|\n\n```\nvar target = new GlideRecord('incident'); \n  target.addNotNullQuery('short_description');\n  target.query();   // Issue the query to the database to get all records\n  while (target.next()) {   \n     // add code here to process the incident record\n  }\n```\n\n### Scoped equivalent\n\nTo use the addNotNullQuery\\(\\) method in a scoped application, use the corresponding scoped method: [addNotNullQuery\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordScopedAPI.md).\n\n## GlideRecord - addNullQuery\\(String fieldName\\)\n\nAdds a filter to return records where the specified field is null.\n\n|Name|Type|Description|\n|----|----|-----------|\n|fieldName|String|The field name.|\n\n|Type|Description|\n|----|-----------|\n|GlideQueryCondition|GlideQueryCondition of records where the specified field is null.|\n\n```\nvar target = new GlideRecord('incident'); \n  target.addNullQuery('short_description');\n  target.query();   // Issue the query to the database to get all records\n  while (target.next()) {   \n     // add code here to process the incident record\n  }\n```\n\n### Scoped equivalent\n\nTo use the addNullQuery\\(\\) method in a scoped application, use the corresponding scoped method: [addNullQuery\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordScopedAPI.md).\n\n## GlideRecord - addQuery\\(String name, Object operator, Object value\\)\n\nProvides the ability to build a request, which when executed, returns the rows from the specified table that match the request.\n\nIf you're familiar with SQL, this method is similar to the \"where\" clause. You can make one or more addQuery\\(\\) calls in a single query. For this method the queries are AND'ed. If any of the query statements need to be OR'ed, use the class [GlideQueryCondition](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideQueryConditionAPI.md).\n\naddQuery\\(\\) is typically called with three parameters; table field, operator, and comparison value. It can be called with only two parameters, table field and comparison value, such as `myObj.addQuery('category','Hardware');`. The operator in this case is assumed to be \"equal to\".\n\nFor additional information on using queries, see [Querying tables in script](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/scripts/c_UsingGlideRecordToQueryTables.md).\n\nAlways test queries on a sub-production instance prior to deploying them on a production instance. An incorrectly constructed encoded query, such as including an invalid field name, produces an invalid query. When the invalid query is run, the invalid part of the query condition is dropped, and the results are based on the valid part of the query, which may return all records from the table. Using an insert\\(\\), update\\(\\), deleteRecord\\(\\), or deleteMultiple\\(\\) method on bad query results can result in data loss.\n\nYou can set the **glide.invalid\\_query.returns\\_no\\_rows** system property to true to have queries with invalid encoded queries return no records. In some cases, the query may still return records in API results even when **glide.invalid\\_query.returns\\_no\\_rows** is set to true. This happens in queries where an invalid query term is used with a WHERE operator. In such queries, the WHERE operator ignores the invalid term\\(s\\) but still interprets and returns the rest of the query statement. For more information about this system property and its functionality, see [Available system properties](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/platform-administration/r_AvailableSystemProperties.md).\n\n**Note:** To enforce query access based on the user, use[addUserQuery\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md).\n\n<table id=\"table_ix2_hvp_dt\" class=\"parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nType\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nname\n\n</td><td>\n\nString\n\n</td><td>\n\nTable field name or path to an attribute within a dynamic attribute store element.Format of the attribute path: `dyn_att_field->attr_name`\n\n-   `dyn_att_field`: Name of a dynamic attribute store field on the table.\n-   `attr_name`: Name of the dynamic attribute.\n\nTable: Dynamic Attribute \\[dynamic\\_attribute\\]\n\n\nSee also [Dynamic Schema](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/platform-administration/dynamic-schema.md).\n\n</td></tr><tr><td>\n\noperator\n\n</td><td>\n\nObject\n\n</td><td>\n\nQuery operator. The available values are dependent on the data type of the *value* parameter.Numbers:\n\n-   =\n-   !=\n-   &gt;\n-   &gt;=\n-   &lt;\n-   &lt;=\n\nStrings \\(must be in upper case\\):\n\n-   =\n-   !=\n-   IN\n-   NOT IN\n-   STARTSWITH\n-   ENDSWITH\n-   CONTAINS\n-   DOES NOT CONTAIN\n-   INSTANCEOF\n\n**Note:** Use CONTAINS instead of the LIKE operator.\n\nDynamic schema operators:\n\n-   =\n-   !=\n-   &lt;\n-   &gt;\n-   &lt;=\n-   &gt;=\n-   BETWEEN\n-   CONTAINS\n-   DOES\\_NOT\\_CONTAIN\n-   ENDSWITH\n-   GT\\_FIELD\n-   GT\\_OR\\_EQUALS\\_FIELD\n-   IN\n-   ISEMPTY\n-   ISNOTEMPTY\n-   IS\\_NOT\\_NULL\n-   IS\\_NULL\n-   LIKE\n-   LT\\_FIELD\n-   LT\\_OR\\_EQUALS\\_FIELD\n-   MATCHES\n-   NOT\\_IN\n-   NOT\\_LIKE\n-   NOT\\_MATCHES\n-   NSAMEAS\n-   SAMEAS\n-   STARTSWITH\n\n</td></tr><tr><td>\n\nvalue\n\n</td><td>\n\nObject\n\n</td><td>\n\nValue on which to query \\(not case-sensitive\\).\n\n</td></tr></tbody>\n</table>|Type|Description|\n|----|-----------|\n|GlideQueryCondition|Reference to the GlideQueryCondition that was added to the GlideRecord.|\n\nThe following example shows how to call this method.\n\n```\nvar rec = new GlideRecord('incident');\nrec.addQuery('active',true);\nrec.addQuery('sys_created_on', \">\", \"2010-01-19 04:05:00\");\nrec.query();\nwhile (rec.next()) { \n rec.active = false;\n gs.print('Active incident ' + rec.number + ' closed');\n rec.update();\n}\n```\n\nThe following example shows how to use the `IN` operator.\n\n```\nvar que = new GlideRecord('incident');\nque.addQuery('number','IN','INC00001,INC00002');\nque.query();\nwhile(que.next()) {\n //do something....\n}\n```\n\nThe following example shows how to call this method using attributes in a dynamic attribute store.\n\n```\nvar gr_Inc = new GlideRecord('incident');\ngr_Inc.addQuery('inc_dynamic_schema->avg_mpg', 'GT_FIELD', 'inc_dynamic_schema2->avg_mpg'); \ngr_Inc.query();\nwhile(gr_Inc.next()) {\n    gs.info(gr_Inc.number + \" Gas Mileage 1: \" + gr_Inc.getDynamicAttributeValue('inc_dynamic_schema->avg_mpg') +  \" GT_FIELD Gas Mileage 2 :\" + gr_Inc.getDynamicAttributeValue('inc_dynamic_schema2->avg_mpg'));\n}\n```\n\n### Scoped equivalent\n\nTo use the addQuery\\(\\) method in a scoped application, use the corresponding scoped method: [addQuery\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordScopedAPI.md).\n\n## GlideRecord - addSystemEncodedQuery\\(String query\\)\n\nAdds a query using an encoded query string. Use this method to bypass query access.\n\nUse this method when system-level access is intended, so that query ACL enforcement is explicitly bypassed for the user. Use[addUserEncodedQuery\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md) to enforce query access.\n\nAdditional methods for system-level access that bypass query ACL checks:\n\n-   [addSystemOrderBy\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md)\n-   [addSystemOrderByDesc\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md)\n-   [addSystemQuery\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md)\n-   [GlideQueryCondition - addSystemCondition\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideQueryConditionAPI.md)\n-   [GlideQueryCondition - addSystemOrCondition\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideQueryConditionAPI.md)\n\nFor information on using this method with GlideRecordSecure, see [Enforcing query ACLs](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/scripts/p_GlideServerAPIs.md).\n\nAlways test queries on a sub-production instance prior to deploying them on a production instance. An incorrectly constructed encoded query, such as including an invalid field name, produces an invalid query. When the invalid query is run, the invalid part of the query condition is dropped, and the results are based on the valid part of the query, which may return all records from the table. Using an insert\\(\\), update\\(\\), deleteRecord\\(\\), or deleteMultiple\\(\\) method on bad query results can result in data loss.\n\nYou can set the **glide.invalid\\_query.returns\\_no\\_rows** system property to true to have queries with invalid encoded queries return no records. In some cases, the query may still return records in API results even when **glide.invalid\\_query.returns\\_no\\_rows** is set to true. This happens in queries where an invalid query term is used with a WHERE operator. In such queries, the WHERE operator ignores the invalid term\\(s\\) but still interprets and returns the rest of the query statement. For more information about this system property and its functionality, see [Available system properties](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/platform-administration/r_AvailableSystemProperties.md).\n\n|Name|Type|Description|\n|----|----|-----------|\n|query|String|An [encoded query string](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/platform-user-interface/c_EncodedQueryStrings.md).|\n\n|Type|Description|\n|----|-----------|\n|None| |\n\nThe following example shows how to return the number value of the first 12 incidents with a priority value of 1 or 2.\n\n```\nvar queryString = \"priority=1^ORpriority=2\";\nvar now_GR = new GlideRecord('incident');\nnow_GR.addSystemEncodedQuery(queryString);\n\nnow_GR.setLimit(12);\nnow_GR.query();\n\nwhile (now_GR.next()) {\n  gs.info(now_GR.getValue('number'));\n}\n```\n\nOutput:\n\n```\n*** Script: INC0002318\n*** Script: INC0000144\n*** Script: INC0006927\n*** Script: INC0003577\n*** Script: INC0006928\n*** Script: INC0000135\n*** Script: INC0005637\n*** Script: INC0003196\n*** Script: INC0002647\n*** Script: INC0004074\n*** Script: INC0003444\n*** Script: INC0001694\n```\n\n## GlideRecord - addSystemOrderBy\\(String name\\)\n\nSpecifies an orderBy column. Use this method to bypass query access.\n\nUse this method when system-level access is intended, so that query ACL enforcement is explicitly bypassed for the user. Use[addUserOrderBy\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md) to enforce query access.\n\nAdditional methods for system-level access that bypass query ACL checks:\n\n-   [addSystemEncodedQuery\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md)\n-   [addSystemQuery\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md)\n-   [GlideQueryCondition - addSystemCondition\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideQueryConditionAPI.md)\n-   [GlideQueryCondition - addSystemOrCondition\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideQueryConditionAPI.md)\n\nCall this method more than once to order by multiple columns. Results are arranged in ascending order. To arrange records in descending order, see [addSystemOrderByDesc\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md).\n\n|Name|Type|Description|\n|----|----|-----------|\n|name|String|Column name to use to order the records in this GlideRecord object.|\n\n|Type|Description|\n|----|-----------|\n|None| |\n\nThe following example shows how to order incident records in ascending order by Short Description.\n\n```\nvar queryString = \"priority=1\";\nvar now_GR = new GlideRecord('incident');\n\nnow_GR.addSystemOrderBy('short_description'); // Ascending Order\nnow_GR.addSystemEncodedQuery(queryString);\n\nnow_GR.setLimit(6);\nnow_GR.query();\n\nwhile (now_GR.next()) {\n  gs.info(now_GR.getValue('short_description'));\n}\n```\n\nOutput:\n\n```\n*** Script: Access token revoked\n*** Script: Access token revoked\n*** Script: Account locked, pls reset my password for Linkedin Sales Navigator\n*** Script: Active Directory (AD) synchronization error\n*** Script: Adobe Photoshop & Digital Publishing Instance is down\n*** Script: Application response time is poor when performing any action in ADP Payroll S...\n```\n\n## GlideRecord - addSystemOrderByDesc\\(String name\\)\n\nSpecifies a descending orderBy column. Use this method to bypass query access.\n\nUse this method when system-level access is intended, so that query ACL enforcement is explicitly bypassed for the user. Use[addUserOrderByDesc\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md) to enforce query access.\n\nAdditional methods for system-level access that bypass query ACL checks:\n\n-   [addSystemEncodedQuery\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md)\n-   [addSystemQuery\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md)\n-   [GlideQueryCondition - addSystemCondition\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideQueryConditionAPI.md)\n-   [GlideQueryCondition - addSystemOrCondition\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideQueryConditionAPI.md)\n\nCall this method more than once to order by multiple columns. Results are arranged in descending order. To arrange records in ascending order, see [addSystemOrderBy\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md).\n\n|Name|Type|Description|\n|----|----|-----------|\n|name|String|Column name to use to order the records in a GlideRecord object.|\n\n|Type|Description|\n|----|-----------|\n|None| |\n\nThe following example shows how to order incident records in descending order by Short Description.\n\n```\nvar queryString = \"priority=2\";\nvar now_GR = new GlideRecord('incident');\n\nnow_GR.addSystemOrderByDesc('short_description'); //Descending Order\nnow_GR.addSystemEncodedQuery(queryString);\n\nnow_GR.setLimit(6);\nnow_GR.query();\n\nwhile (now_GR.next()) {\n  gs.info(now_GR.getValue('short_description'));\n}\n```\n\nOutput:\n\n```\n*** Script: Xignite U.S. and Global Real Time Quotes upgrade to the latest version\n*** Script: Xignite Company, Market and Industry News Headlines upgrade to the latest ver...\n*** Script: Workday Talent Management Instance relocation from US datacenter to Hongkong ...\n*** Script: Warning displayed while launching Tableau Server\n*** Script: Warning displayed while launching SAP Financial Accounting\n*** Script: Warning displayed while launching Jive Daily\n```\n\n## GlideRecord - addSystemQuery\\(String name, Object operator, Object value\\)\n\nProvides the ability to build a request, which when executed, returns the rows from the specified table, that match the request. Use this method to bypass query access.\n\nUse this method when system-level access is intended, so that query ACL enforcement is explicitly bypassed for the user. Use[addUserQuery\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md) to enforce query access.\n\nAdditional methods for system-level access that bypass query ACL checks:\n\n-   [addSystemEncodedQuery\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md)\n-   [addSystemOrderBy\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md)\n-   [addSystemOrderByDesc\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md)\n-   [GlideQueryCondition - addSystemCondition\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideQueryConditionAPI.md)\n-   [GlideQueryCondition - addSystemOrCondition\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideQueryConditionAPI.md)\n\nAlways test queries on a sub-production instance prior to deploying them on a production instance. An incorrectly constructed encoded query, such as including an invalid field name, produces an invalid query. When the invalid query is run, the invalid part of the query condition is dropped, and the results are based on the valid part of the query, which may return all records from the table. Using an insert\\(\\), update\\(\\), deleteRecord\\(\\), or deleteMultiple\\(\\) method on bad query results can result in data loss.\n\nYou can set the **glide.invalid\\_query.returns\\_no\\_rows** system property to true to have queries with invalid encoded queries return no records. In some cases, the query may still return records in API results even when **glide.invalid\\_query.returns\\_no\\_rows** is set to true. This happens in queries where an invalid query term is used with a WHERE operator. In such queries, the WHERE operator ignores the invalid term\\(s\\) but still interprets and returns the rest of the query statement. For more information about this system property and its functionality, see [Available system properties](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/platform-administration/r_AvailableSystemProperties.md).\n\n<table id=\"table_ix2_hvp_dt\" class=\"parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nType\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nname\n\n</td><td>\n\nString\n\n</td><td>\n\nTable field name.\n\n</td></tr><tr><td>\n\noperator\n\n</td><td>\n\nObject\n\n</td><td>\n\nQuery operator. The available values are dependent on the data type of the *value* parameter.Numbers:\n\n-   =\n-   !=\n-   &gt;\n-   &gt;=\n-   &lt;\n-   &lt;=\n\nStrings \\(must be in upper case\\):\n\n-   =\n-   !=\n-   IN\n-   NOT IN\n-   STARTSWITH\n-   ENDSWITH\n-   CONTAINS\n-   DOES NOT CONTAIN\n-   INSTANCEOF\n\n**Note:** Use CONTAINS instead of the LIKE operator.\n\nDynamic schema operators:\n\n-   =\n-   !=\n-   &lt;\n-   &gt;\n-   &lt;=\n-   &gt;=\n-   BETWEEN\n-   CONTAINS\n-   DOES\\_NOT\\_CONTAIN\n-   ENDSWITH\n-   GT\\_FIELD\n-   GT\\_OR\\_EQUALS\\_FIELD\n-   IN\n-   ISEMPTY\n-   ISNOTEMPTY\n-   IS\\_NOT\\_NULL\n-   IS\\_NULL\n-   LIKE\n-   LT\\_FIELD\n-   LT\\_OR\\_EQUALS\\_FIELD\n-   MATCHES\n-   NOT\\_IN\n-   NOT\\_LIKE\n-   NOT\\_MATCHES\n-   NSAMEAS\n-   SAMEAS\n-   STARTSWITH\n\n</td></tr><tr><td>\n\nvalue\n\n</td><td>\n\nObject\n\n</td><td>\n\nValue on which to query \\(not case-sensitive\\).\n\n</td></tr></tbody>\n</table>|Type|Description|\n|----|-----------|\n|[GlideQueryCondition](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideQueryConditionAPI.md)|The query condition that was added to the GlideRecord.|\n\nThe following example shows how to explicitly return all active users named Fred.\n\n```\nvar rec = new GlideRecord('sys_user');\nrec.addSystemQuery(\"first_name\", \"=\", \"Fred\");\nrec.query();\n\nwhile (rec.next()) {\n  gs.info('Active user ' + rec.getValue('last_name'));\n}\n```\n\nOutput:\n\n```\nActive user Luddy\nActive user Kunde\n```\n\n## GlideRecord - addUserEncodedQuery\\(String query\\)\n\nAdds a query using an encoded query string. Use this method to enforce query access based on the user.\n\nThis method returns only records that the current user has query access to \\(based on ACLs\\).\n\nRelated methods:\n\n-   [addEncodedQuery\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordScopedAPI.md) provides the same functionality without ACL enforcement.\n-   [addSystemEncodedQuery\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md) bypasses query access checks.\n\nAdditional methods for enforcing query ACL checks:\n\n-   [addUserOrderBy\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md)\n-   [addUserOrderByDesc\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md)\n-   [addUserQuery\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md)\n-   [GlideQueryCondition - addUserCondition\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideQueryConditionAPI.md)\n-   [GlideQueryCondition - addUserOrCondition\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideQueryConditionAPI.md)\n\nFor information on using this method with GlideRecordSecure, see [Enforcing query ACLs](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/scripts/p_GlideServerAPIs.md).\n\nAlways test queries on a sub-production instance prior to deploying them on a production instance. An incorrectly constructed encoded query, such as including an invalid field name, produces an invalid query. When the invalid query is run, the invalid part of the query condition is dropped, and the results are based on the valid part of the query, which may return all records from the table. Using an insert\\(\\), update\\(\\), deleteRecord\\(\\), or deleteMultiple\\(\\) method on bad query results can result in data loss.\n\nYou can set the **glide.invalid\\_query.returns\\_no\\_rows** system property to true to have queries with invalid encoded queries return no records. In some cases, the query may still return records in API results even when **glide.invalid\\_query.returns\\_no\\_rows** is set to true. This happens in queries where an invalid query term is used with a WHERE operator. In such queries, the WHERE operator ignores the invalid term\\(s\\) but still interprets and returns the rest of the query statement. For more information about this system property and its functionality, see [Available system properties](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/platform-administration/r_AvailableSystemProperties.md).\n\n|Name|Type|Description|\n|----|----|-----------|\n|query|String|An [encoded query string](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/platform-user-interface/c_EncodedQueryStrings.md).|\n\n|Type|Description|\n|----|-----------|\n|None| |\n\nThe following example shows how to return the number value of the first 12 incidents with a priority value of 1 or 2.\n\n```\nvar queryString = \"priority=1^ORpriority=2\";\nvar now_GR = new GlideRecord('incident');\nnow_GR.addUserEncodedQuery(queryString);\n\nnow_GR.setLimit(12);\nnow_GR.query();\n\nwhile (now_GR.next()) {\n  gs.info(now_GR.getValue('number'));\n}\n```\n\nOutput:\n\n```\n*** Script: INC0002318\n*** Script: INC0000144\n*** Script: INC0006927\n*** Script: INC0003577\n*** Script: INC0006928\n*** Script: INC0000135\n*** Script: INC0005637\n*** Script: INC0003196\n*** Script: INC0002647\n*** Script: INC0004074\n*** Script: INC0003444\n*** Script: INC0001694\n```\n\n## GlideRecord - addUserOrderBy\\(String name\\)\n\nSpecifies an orderBy column. Use this method to enforce query access based on the user.\n\nThis method returns only records that the current user has query access to \\(based on ACLs\\).\n\nRelated methods:\n\n-   [orderBy\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md) provides the same functionality without ACL enforcement.\n-   [addSystemOrderBy\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md) bypasses query access checks.\n\nAdditional methods for enforcing query ACL checks:\n\n-   [addUserEncodedQuery\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md)\n-   [addUserQuery\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md)\n-   [GlideQueryCondition - addUserCondition\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideQueryConditionAPI.md)\n-   [GlideQueryCondition - addUserOrCondition\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideQueryConditionAPI.md)\n\nCall this method more than once to order by multiple columns. Results are arranged in ascending order. To arrange records in descending order, see [addUserOrderByDesc\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md).\n\n|Name|Type|Description|\n|----|----|-----------|\n|name|String|Column name to use to order the records in this GlideRecord object.|\n\n|Type|Description|\n|----|-----------|\n|None| |\n\nThe following example shows how to order incident records in ascending order by Short Description.\n\n```\nvar queryString = \"priority=1\";\nvar now_GR = new GlideRecord('incident');\n\nnow_GR.addUserOrderBy('short_description'); // Ascending Order\nnow_GR.addUserEncodedQuery(queryString);\n\nnow_GR.setLimit(6);\nnow_GR.query();\n\nwhile (now_GR.next()) {\n  gs.info(now_GR.getValue('short_description'));\n}\n```\n\nOutput:\n\n```\n*** Script: Access token revoked\n*** Script: Access token revoked\n*** Script: Account locked, pls reset my password for Linkedin Sales Navigator\n*** Script: Active Directory (AD) synchronization error\n*** Script: Adobe Photoshop & Digital Publishing Instance is down\n*** Script: Application response time is poor when performing any action in ADP Payroll S...\n```\n\n## GlideRecord - addUserOrderByDesc\\(String name\\)\n\nSpecifies a descending orderBy column. Use this method to enforce query access based on the user.\n\nThis method returns only records that the current user has query access to \\(based on ACLs\\).\n\nRelated methods:\n\n-   [orderByDesc\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md) provides the same functionality without ACL enforcement.\n-   [addSystemOrderByDesc\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md) bypasses query access checks.\n\nAdditional methods for enforcing query ACL checks:\n\n-   [addUserEncodedQuery\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md)\n-   [addUserQuery\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md)\n-   [GlideQueryCondition - addUserCondition\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideQueryConditionAPI.md)\n-   [GlideQueryCondition - addUserOrCondition\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideQueryConditionAPI.md)\n\nCall this method more than once to order by multiple columns. Results are arranged in descending order. To arrange records in ascending order, see [addUserOrderBy\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md).\n\n|Name|Type|Description|\n|----|----|-----------|\n|name|String|Column name to use to order the records in a GlideRecord object.|\n\n|Type|Description|\n|----|-----------|\n|None| |\n\nThe following example shows how to order incident records in descending order by Short Description.\n\n```\nvar queryString = \"priority=2\";\nvar now_GR = new GlideRecord('incident');\n\nnow_GR.addUserOrderByDesc('short_description'); //Descending Order\nnow_GR.addUserEncodedQuery(queryString);\n\nnow_GR.setLimit(6);\nnow_GR.query();\n\nwhile (now_GR.next()) {\n  gs.info(now_GR.getValue('short_description'));\n}\n```\n\nOutput:\n\n```\n*** Script: Xignite U.S. and Global Real Time Quotes upgrade to the latest version\n*** Script: Xignite Company, Market and Industry News Headlines upgrade to the latest ver...\n*** Script: Workday Talent Management Instance relocation from US datacenter to Hongkong ...\n*** Script: Warning displayed while launching Tableau Server\n*** Script: Warning displayed while launching SAP Financial Accounting\n*** Script: Warning displayed while launching Jive Daily\n```\n\n## GlideRecord - addUserQuery\\(String name, Object operator, Object value\\)\n\nProvides the ability to build a request, which when executed, returns the rows from the specified table that match the request. The calling user must have access to perform the specified query operation on the field for this request to be added. Use this method to enforce query access based on the user.\n\nThis method returns only records that the current user has query access to \\(based on ACLs\\).\n\nRelated methods:\n\n-   [addQuery\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md) provides the same functionality without ACL enforcement.\n-   [addSystemQuery\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md) bypasses query access checks.\n\nAdditional methods for enforcing query ACL checks:\n\n-   [addUserOrderBy\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md)\n-   [addUserEncodedQuery\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md)\n-   [addUserOrderByDesc\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md)\n-   [GlideQueryCondition - addUserCondition\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideQueryConditionAPI.md)\n-   [GlideQueryCondition - addUserOrCondition\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideQueryConditionAPI.md)\n\nAlways test queries on a sub-production instance prior to deploying them on a production instance. An incorrectly constructed encoded query, such as including an invalid field name, produces an invalid query. When the invalid query is run, the invalid part of the query condition is dropped, and the results are based on the valid part of the query, which may return all records from the table. Using an insert\\(\\), update\\(\\), deleteRecord\\(\\), or deleteMultiple\\(\\) method on bad query results can result in data loss.\n\nYou can set the **glide.invalid\\_query.returns\\_no\\_rows** system property to true to have queries with invalid encoded queries return no records. In some cases, the query may still return records in API results even when **glide.invalid\\_query.returns\\_no\\_rows** is set to true. This happens in queries where an invalid query term is used with a WHERE operator. In such queries, the WHERE operator ignores the invalid term\\(s\\) but still interprets and returns the rest of the query statement. For more information about this system property and its functionality, see [Available system properties](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/platform-administration/r_AvailableSystemProperties.md).\n\n<table id=\"table_ix2_hvp_dt\" class=\"parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nType\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nname\n\n</td><td>\n\nString\n\n</td><td>\n\nTable field name.\n\n</td></tr><tr><td>\n\noperator\n\n</td><td>\n\nObject\n\n</td><td>\n\nQuery operator. The available values are dependent on the data type of the *value* parameter.Numbers:\n\n-   =\n-   !=\n-   &gt;\n-   &gt;=\n-   &lt;\n-   &lt;=\n\nStrings \\(must be in upper case\\):\n\n-   =\n-   !=\n-   IN\n-   NOT IN\n-   STARTSWITH\n-   ENDSWITH\n-   CONTAINS\n-   DOES NOT CONTAIN\n-   INSTANCEOF\n\n**Note:** Use CONTAINS instead of the LIKE operator.\n\nDynamic schema operators:\n\n-   =\n-   !=\n-   &lt;\n-   &gt;\n-   &lt;=\n-   &gt;=\n-   BETWEEN\n-   CONTAINS\n-   DOES\\_NOT\\_CONTAIN\n-   ENDSWITH\n-   GT\\_FIELD\n-   GT\\_OR\\_EQUALS\\_FIELD\n-   IN\n-   ISEMPTY\n-   ISNOTEMPTY\n-   IS\\_NOT\\_NULL\n-   IS\\_NULL\n-   LIKE\n-   LT\\_FIELD\n-   LT\\_OR\\_EQUALS\\_FIELD\n-   MATCHES\n-   NOT\\_IN\n-   NOT\\_LIKE\n-   NOT\\_MATCHES\n-   NSAMEAS\n-   SAMEAS\n-   STARTSWITH\n\n</td></tr><tr><td>\n\nvalue\n\n</td><td>\n\nObject\n\n</td><td>\n\nValue on which to query \\(not case-sensitive\\).\n\n</td></tr></tbody>\n</table>|Type|Description|\n|----|-----------|\n|[GlideQueryCondition](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideQueryConditionAPI.md)|The query condition that was added to the GlideRecord.|\n\nThe following shows how to return only users named Fred that the current user has permission to see.\n\n```\nvar rec = new GlideRecord('sys_user');\nrec.addUserQuery(\"first_name\", \"=\", \"Fred\");\nrec.query();\n\nwhile (rec.next()) {\n  gs.info('Active user ' + rec.getValue('last_name'));\n}\n```\n\nOutput:\n\n```\nActive user Luddy\nActive user Kunde\n```\n\n## GlideRecord - addValue\\(String field, Number value\\)\n\nProvides atomic add and subtract operations on a specified number field at the database level for the current GlideRecord object.\n\nTypically, a GlideRecord object is written as one record in a database. Individual field values are stored as defined. For code that adds a value to a GlideRecord field, it simply saves the field to the database with the new value, rather than atomically incrementing it.\n\nFor example, when the following code is executed, the value of the u\\_count field in the database is 2.\n\n```\ngs.print(now_now_GR.u_count); // \"1\" \nnow_GR.u_count += 1; \nnow_GR.update(); \nnow_GR.get(now_now_GR.sys_id); \ngs.print(now_now_GR.u_count); // \"2\"   \n```\n\nIf another user concurrently runs identical code, instead of the two operations each adding 1 to u\\_count, the net effect is that u\\_count only contains 2, with one operation's update actually being lost.\n\nConversely, the addValue\\(\\) method performs the addition/subtraction in the database when the record is updated as an atomic operation. Two operations running concurrently each properly update the field.\n\n```\ngs.print(now_now_GR.u_count); // \"1\" \nnow_GR.addValue(\"u_count\", 1); \nnow_GR.update(); \nnow_GR.get(now_GR); // The record must be reloaded from the database to observe the result\ngs.print(now_now_GR.u_count); // \"3\", if executed concurrently with another user \n```\n\n**Note:** The new value is not read back from the database unless explicitly done so.\n\nLike setValue\\(\\), addValue\\(\\) changes only take effect in the database after a subsequent call to update\\(\\) or insert\\(\\). If insert\\(\\) is called, the specified field is initialized with the **value** parameter passed into addValue\\(\\).\n\n**Note:** If setValue\\(\\) is called for the specified field prior to calling addValue\\(\\), the addValue\\(\\) method is not processed and an error message is logged.\n\n<table id=\"table_h43_tjt_hlb\" class=\"parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nType\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nfield\n\n</td><td>\n\nString\n\n</td><td>\n\nThe name of the field in this GlideRecord to modify. If the associated field is not a numeric type, the operation is ignored.\n\n</td></tr><tr><td>\n\nvalue\n\n</td><td>\n\nNumber\n\n</td><td>\n\nThe amount to add to the value when the record is saved. To perform a subtraction operation, simply pass a negative value.\n\n</td></tr></tbody>\n</table>|Type|Description|\n|----|-----------|\n|void| |\n\nShows a value being added.\n\n```\ngs.print(now_GR.u_count); // \"1\" \nnow_GR.addValue(\"u_count\", 1); \nnow_GR.update(); \nnow_GR.get(now_GR.sys_id); // The record must be reloaded from the database to observe the result\ngs.print(now_GR.u_count);\n```\n\nOutput: 2\n\nShows a value being subtracted.\n\n```\ngs.print(now_GR.u_count); // \"4\" \nnow_GR.addValue(\"u_count\", -1); \nnow_GR.update(); \nnow_GR.get(now_GR.sys_id); // The record must be reloaded from the database to observe the result\ngs.print(now_GR.u_count);\n```\n\nOutput: 3\n\n## GlideRecord - applyEncodedQuery\\(String queryString\\)\n\nSets the values of the specified encoded query terms and applies them to the current GlideRecord.\n\n|Name|Type|Description|\n|----|----|-----------|\n|queryString|String|Encoded query to apply to the current GlideRecord.|\n\n|Type|Description|\n|----|-----------|\n|None| |\n\n```\nfunction createAcl(table, role) {\n  gs.print(\"Checking security on table \" + table);\n  var now_GR = new GlideRecord(\"sys_security_acl\");\n  now_GR.addQuery(\"name\", table);\n  now_GR.addQuery(\"operation\", \"read\");\n  now_GR.query();\n  var encQuery = now_GR.getEncodedQuery();\n  if (now_GR.next()) {\n    // existing acl found so use it\n    createAclRole(now_GR.sys_id.toString(), role);\n    return;\n  } else {\n  now_GR.initialize();\n  now_GR.applyEncodedQuery(encQuery);\n  var acl = now_GR.insert();\n    gs.print(\"Added read access control on \" + table);\n    createAclRole(acl, role);\n  } \n}\n```\n\n## GlideRecord - applyTemplate\\(String template\\)\n\nApply a template record from the Template table \\[sys\\_template\\] to the current record. If the specified template is not found, no action is taken.\n\n**Note:** This method automatically instantiates a now\\_GR.insert\\(\\) method if a template has the **Next Related Child Template** field filled. For information, see [Create templates for related task records](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/platform-administration/create-templates-for-related-task-records.md).\n\n|Name|Type|Description|\n|----|----|-----------|\n|template|String|Name of a template from the Templates \\[sys\\_template\\] table.|\n\n|Type|Description|\n|----|-----------|\n|void| |\n\n```\nvar rec1 = new GlideRecord(\"incident\");\nrec1.initialize();\nrec1.applyTemplate(\"my_incident_template\");\nrec1.insert();\n```\n\n## GlideRecord - autoSysFields\\(Boolean e\\)\n\nEnables or disables the update to the fields sys\\_updated\\_by, sys\\_updated\\_on, sys\\_mod\\_count, sys\\_created\\_by, and sys\\_created\\_on. This is often used for manually updating field values on a record while leaving historical information unchanged.\n\n**Warning:** Use caution if you use this method. When you use this method the sys\\_mod\\_count field will not be incremented, and other sys\\_ fields will not be updated. This can break functionality including, but not limited to, the Activity Formatter, History Sets, Notifications, and Metrics.\n\n|Name|Type|Description|\n|----|----|-----------|\n|e|Boolean|If false disables updates to sys\\_updated\\_by, sys\\_updated\\_on, sys\\_mod\\_count, sys\\_created\\_by, and sys\\_created\\_on.|\n\n|Type|Description|\n|----|-----------|\n|void| |\n\n```\nvar inc = new GlideRecord('incident');\n \n// Change all Open(1) incidents to Active(2)\n \ninc.addQuery('state', 1);\ninc.query();\n \nwhile (inc.next()) {\n  inc.autoSysFields(false);  // Do not update sys_updated_by, sys_updated_on, sys_mod_count, sys_created_by, and sys_created_on\n  inc.setWorkflow(false);    // Do not run any other business rules\n  inc.setValue('state', 2);\n  inc.update();\n}\n```\n\n## GlideRecord - canCreate\\(\\)\n\nDetermines if the access control rules \\(which includes the user's role\\) permit inserting new records in this table.\n\n|Name|Type|Description|\n|----|----|-----------|\n|None| | |\n\n<table id=\"table_ryz_pwp_dt\" class=\"returns\"><thead><tr><th>\n\nType\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nBoolean\n\n</td><td>\n\nFlag that indicates whether the user's roles permit creating of records in this table.Possible values:\n\n-   true: Creating permitted\n-   false: Creating is not permitted\n\n</td></tr></tbody>\n</table>This example shows whether records can be created on the benefit\\_plan table.\n\n```\ncanCreateBenefitPlan : function() {\n  var now_GR = new GlideRecord('benefit_plan');\n  return now_GR.canCreate();\n}\n```\n\n### Scoped equivalent\n\nTo use the canCreate\\(\\) method in a scoped application, use the corresponding scoped method: [canCreate\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordScopedAPI.md).\n\n## GlideRecord - canDelete\\(\\)\n\nDetermines if the access control rules \\(which includes the user's role\\) permit deletion of records in this table.\n\n|Name|Type|Description|\n|----|----|-----------|\n|None| | |\n\n<table id=\"table_lmz_zwp_dt\" class=\"returns\"><thead><tr><th>\n\nType\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nBoolean\n\n</td><td>\n\nFlag that indicates whether the user's roles permit deleting of records in this table.Valid values:\n\n-   true: Deleting permitted\n-   false: Deleting is not permitted\n\n</td></tr></tbody>\n</table>```\nvar att = new GlideRecord('sys_attachment');\natt.get('$[sys_attachment.sys_id]');\nvar sm = GlideSecurityManager.get();\nvar checkMe = 'record/sys_attachment/delete';\nvar canDelete = sm.hasRightsTo(checkMe, att);\ngs.log('canDelete: ' + canDelete);\n```\n\n### Scoped equivalent\n\nTo use the canDelete\\(\\) method in a scoped application, use the corresponding scoped method: [canDelete\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordScopedAPI.md).\n\n## GlideRecord - canRead\\(\\)\n\nIndicates whether the Access Control Rules \\(ACLs\\) permit the current user to read the current record within the associated GlideRecord table. This method evaluates all available ACLs for the specific resource.\n\n**Note:** You shouldn’t use this method to check for table-level access. A single call to this method might not be sufficient to get a conclusive table-level access rights check result. To perform a table-level access check, use the GlideSecurityManager.hasRightsTo\\(\\) method.\n\nFor additional information on ACLs, see [Access Controls Evaluation Order](https://developer.servicenow.com/dev.do#!/learn/learning-plans/yokohama/servicenow_application_developer/app_store_learnv2_securingapps_yokohama_access_controls_evaluation_order).\n\n|Name|Type|Description|\n|----|----|-----------|\n|None| | |\n\n<table id=\"table_d3g_4xp_dt\" class=\"returns\"><thead><tr><th>\n\nType\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nBoolean\n\n</td><td>\n\nFlag that indicates whether the user's roles permit reading of the current record.Valid values:\n\n-   true: Reading permitted\n-   false: Reading isn't permitted\n\n</td></tr></tbody>\n</table>This example shows how to iterate through the Incident \\[incident\\] table and check if the user has read rights to each record.\n\n```\nvar grTable = new GlideRecord('incident');\ngrTable.query();\nwhile (grTable.next()) {\n  if (grTable.canRead()) \n\t\t…\n}\n```\n\n### Scoped equivalent\n\nTo use the canRead\\(\\) method in a scoped application, use the corresponding scoped method: [canRead\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordScopedAPI.md).\n\n## GlideRecord - canWrite\\(\\)\n\nDetermines if the access control rules \\(which includes the user's role\\) permit updates to records in this table.\n\n|Name|Type|Description|\n|----|----|-----------|\n|None| | |\n\n<table id=\"table_trp_xxp_dt\" class=\"returns\"><thead><tr><th>\n\nType\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nBoolean\n\n</td><td>\n\nFlag that indicates whether the user's roles permit writing of records in this table.Valid values:\n\n-   true: Writing permitted\n-   false: Writing is not permitted\n\n</td></tr></tbody>\n</table>This example shows whether records can be written to the benefit\\_plan table.\n\n```\ncanWriteBenefitPlan : function() {\n  var now_GR = new GlideRecord('benefit_plan');\n  return now_GR.canWrite();\n}\n```\n\n### Scoped equivalent\n\nTo use the canWrite\\(\\) method in a scoped application, use the corresponding scoped method: [canWrite\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordScopedAPI.md).\n\n## GlideRecord - changes\\(\\)\n\nDetermines whether any of the fields in the record have changed.\n\n|Name|Type|Description|\n|----|----|-----------|\n|None| | |\n\n<table id=\"table_pfg_gyp_dt\" class=\"returns\"><thead><tr><th>\n\nType\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nBoolean\n\n</td><td>\n\nFlag that indicates whether there are changes in the specified record.Possible values:\n\n-   true: Fields in the specified record have changed.\n-   false: No fields have changed.\n\n</td></tr></tbody>\n</table>This example shows how to check if there are changes in an incident record.\n\n```\nvar now_GR = new GlideRecord(\"incident\");\nnow_GR.query();\nnow_GR.next();\nif (now_GR.changes()) {\n  gs.print(\"The incident record reported changes right after being read\");\n} else {\n  gs.print(\"The incident record has not changed\");\n}\n```\n\n### Scoped equivalent\n\nTo implement this functionality in a scoped application, add code similar to the following:\n\n```\nvar now_GR = new GlideRecord(\"incident\");\n   now_GR.get(\"965c9e5347c12200e0ef563dbb9a7156\");\n   now_GR.short_description = \"test\";\n   var elements = now_GR.getElements();\n   var hasChanged = false;\n   for(var i=0; i < elements.length;i++){\n     var element = elements[i];\n     hasChanged = hasChanged || element.changes();\n     gs.info(element.getName() + \":\" + element.changes());\n   }\n   gs.info(hasChanged);\n```\n\n## GlideRecord - chooseWindow\\(Number firstRow, Number lastRow, Boolean forceCount\\)\n\nSets a range of rows to be returned by subsequent queries.\n\n-   **Using setLimit\\(\\) with chooseWindow\\(\\)**\n\n    The setLimit\\(\\) method implicitly calls the chooseWindow\\(\\) method and might cause unexpected results when used with chooseWindow\\(\\) in a query.\n\n    -   If the chooseWindow\\(\\) method is called first, its record window is overwritten by the setLimit\\(\\) method.\n\n        Using the following lines in a query returns 100 records starting at row 1:\n\n        ```\n        grIncident.chooseWindow(20,30);\n        grIncident.setLimit(100);\n        ```\n\n    -   If the setLimit\\(\\) method is called first, the window set by chooseWindow\\(\\) is used and the limit is overwritten.\n\n        Using the following lines in a query returns 10 records starting at row 21:\n\n        ```\n        grIncident.setLimit(5);\n        grIncident.chooseWindow(20,30);\n        ```\n\n        **Note:** Running query\\(\\) with the chooseWindow\\(\\) method triggers a `COUNT(*)` query, which can result in slow performance on tables with a large number of records. You can use setLimit\\(\\) before chooseWindow\\(\\) to skip running the `COUNT(*)` query, but the same performance benefit is achievable using setNoCount\\(\\).\n\n\nSee also:\n\n-   [query\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md)\n-   [setLimit\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md)\n-   [setNoCount\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md)\n\n<table id=\"table_vy2_525_jq\" class=\"parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nType\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nfirstRow\n\n</td><td>\n\nNumber\n\n</td><td>\n\nZero-based index of the starting row for the range, inclusive. \\(A value of 0 returns the first row.\\)\n\n</td></tr><tr><td>\n\nlastRow\n\n</td><td>\n\nNumber\n\n</td><td>\n\nZero-based index of the ending row for the range, exclusive.For example, if **firstRow** = 1 and **lastRow** = 5, four records are returned \\(2-5\\).\n\n</td></tr><tr><td>\n\nforceCount\n\n</td><td>\n\nBoolean\n\n</td><td>\n\nOptional. Flag that indicates whether to force a row count query. In most implementations of this call, the row count is performed. There are some outlying cases, such as text searches, were a row count is not performed. Setting this flag ensures that the row count occurs.Valid values:\n\n-   true: Row count always occurs.\n-   false: Row count occurs if implemented in normal execution of method.\n\n Default: false\n\n</td></tr></tbody>\n</table>|Type|Description|\n|----|-----------|\n|void| |\n\nThis example shows how to return records 3 and 4 from the Incident \\[incident\\] table.\n\n```\nvar now_GR = new GlideRecord('incident');\nnow_GR.orderBy('number');\nnow_GR.chooseWindow(2, 4);\nnow_GR.query();\nwhile (now_GR.next()) {\n  gs.info(now_GR.getValue('number') + ' is within window');\n}\n```\n\nOutput:\n\n```\n*** Script: INC0000003 is within window\n*** Script: INC0000004 is within window\n```\n\n## GlideRecord - deleteMultiple\\(\\)\n\nDeletes all records that satisfy the query.\n\nThis method does not delete attachments.\n\nDot-walking is not supported for this method. When using the deleteMultiple\\(\\) function on referenced tables, all the records in the table are deleted. Also, when using deleteRecord\\(\\) to cascade delete, prior calls to setWorkflow\\(\\) on the same GlideRecord object are ignored.\n\nDo not use deleteMultiple\\(\\) on tables with currency fields. Always delete each record individually. Also, do not use this method with the chooseWindow\\(\\) or setLimit\\(\\) methods when working with large tables. The setLimit\\(\\) method does not limit the number of records that are deleted with deleteMultiple\\(\\). All records returned by the query are deleted regardless of setLimit\\(\\).\n\nThe **glide.db.forced.chunk.threshold** system property sets the threshold above which forces chunk record deletions and updates. Chunking helps to prevent non-primary key deletions on huge tables from causing replication problems. For more information, see [Available system properties](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/platform-administration/r_AvailableSystemProperties.md).\n\n**Note:** When using deleteMultiple\\(\\) to cascade delete, prior calls to setWorkflow\\(\\) on the same GlideRecord object are ignored.\n\n|Name|Type|Description|\n|----|----|-----------|\n|None| | |\n\n|Type|Description|\n|----|-----------|\n|None| |\n\nThis example shows how to delete all inactive records from the Incident table.\n\n```\nvar now_GR = new GlideRecord('incident');\nnow_GR.addQuery('active','false');\nnow_GR.query();\nnow_GR.deleteMultiple();\n```\n\n### Scoped equivalent\n\nTo use the deleteMultiple\\(\\) method in a scoped application, use the corresponding scoped method: [deleteMultiple\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordScopedAPI.md).\n\n## GlideRecord - deleteRecord\\(\\)\n\nDeletes a single record.\n\n|Name|Type|Description|\n|----|----|-----------|\n|None| | |\n\n<table id=\"table_yqy_s1x_dt\" class=\"returns\"><thead><tr><th>\n\nType\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nBoolean\n\n</td><td>\n\nFlag that indicates whether the record was successfully deleted.Possible values:\n\n-   true: Record was deleted.\n-   false: No record was found to delete.\n\n</td></tr></tbody>\n</table>This example shows how to delete all inactive records from the Incident table.\n\n```\nvar rec = new GlideRecord('incident');\nrec.addQuery('active',false);\nrec.query();\nwhile (rec.next()) { \n gs.info('Inactive incident ' + rec.number + ' deleted');\n rec.deleteRecord();\n}\n```\n\nOutput:\n\n```\nInactive incident INC0010010 deleted\nInactive incident INC0010011 deleted\n```\n\nThis example shows how to delete a record from the Incident table immediately after it is inserted. The incident GlideRecord must be reloaded after the insert before it can be deleted.\n\n```\nvar grTicket = new GlideRecord('incident');\ngrTicket.initialize();\ngrTicket.short_description = 'Example ticket';\ngrTicket.work_notes = 'An update about the ticket';\nvar ins_sys_id = grTicket.insert(); // Insert the record\ngrTicket.get(ins_sys_id); // Reload the inserted record\ngs.info(grTicket.deleteRecord()); // Delete the record\n```\n\nOutput:\n\n```\ntrue\n```\n\n### Scoped equivalent\n\nTo use the deleteRecord\\(\\) method in a scoped application, use the corresponding scoped method: [deleteRecord\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordScopedAPI.md).\n\n## GlideRecord - disableSysIdInOptimization\\(\\)\n\nDisables the default optimization that prevents an extra database query from running when a user passes in a large number of sys\\_ids, such as `grIncident.addQuery('sys_id', 'IN', listOf200SysIds)`.\n\nThis method only effects the GlideRecord on which it’s called. To modify the sys\\_id limit optimization for all GlideRecords, adjust the value in the **glide.db.first\\_pass\\_sys\\_id\\_list\\_size.max** system property \\(default 100\\).\n\nIf you don't either call this method or adjust the **glide.db.first\\_pass\\_sys\\_id\\_list\\_size.max** system property and pass a list that contains more sys\\_id entries than defined in **glide.db.first\\_pass\\_sys\\_id\\_list\\_size.max**, the returned value from GlideRecord.getRowCount\\(\\) may be incorrect.\n\n|Name|Type|Description|\n|----|----|-----------|\n|None| | |\n\n|Type|Description|\n|----|-----------|\n|None| |\n\nThe following code example shows how to use the disableSysIdInOptimiation\\(\\) method to disable the sys\\_id limit optimization when passing an Incident sys\\_id list that contains 200 entries.\n\n```\nvar listOf200SysIds = [ ... ]; // 200 comma separated sys_ids\nvar grIncident = new GlideRecord('incident');\ngrIncident.addQuery('sys_id', 'IN', listOf200SysIds);\ngrIncident.disableSysIdInOptimization(); // Rowcount could be incorrect without this method call\ngrIncident.query();\nif (grIncident.next())\n    gs.info(\"Rowcount: \" + grIncident.getRowCount());\n```\n\nOutput:\n\n```\nRowcount: 200\n```\n\n## GlideRecord - find\\(String columnName, String value\\)\n\nReturns true if any record has a matching value in the specified column. If found, it also moves to the first record that matches, essentially executing next\\(\\) until the record is returned.\n\n**Note:** This method creates a record instead of updating the existing record if you apply the update\\(\\) method after modifying the GlideRecord. To avoid creating a record, call the next\\(\\) method before calling find\\(\\). For example:\n\n```\nvar existingMaterials = new GlideRecord('u_m2m_material_num_service_instance');\nexistingMaterials.addQuery('u_service_instance', serviceInstance.sys_id);\nexistingMaterials.query();\nexistingMaterials.next(); // This line added to prevent new record creation\n\nexistingMaterials.find('u_material_number', 'ca41b9fd37a84200fdc25ca543990ed8');\n\nexistingMaterials.u_material_quantity = 5;\nexistingMaterials.update(\"Modify request via catalog\");\n```\n\nSee also:\n\n-   [next\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md)\n-   [update\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordAPI.md)\n\n|Name|Type|Description|\n|----|----|-----------|\n|columnName|String|Field name to search.|\n|value|String|Value to check for in the specified field.|\n\n<table id=\"table_l1m_qyp_dt\" class=\"returns\"><thead><tr><th>\n\nType\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nBoolean\n\n</td><td>\n\nFlag that indicates whether any record within the current table has a matching value in the specified field.Possible values:\n\n-   true: Matching field.\n-   false: No matching field.\n\n</td></tr></tbody>\n</table>This example shows how to find a record in the Incident table with \"Critical\" in the short description field.\n\n```\nvar now_GR = new GlideRecord(\"incident\");\nnow_GR.query();\nvar shortDescription = \"Critical\";\nif (now_GR.find(\"short_description\", shortDescription)) {\n  gs.print(\"An incident with the specified field value was found\");\n  var recordID = now_GR.getValue(\"sys_id\");\n  gs.print(\"Found in the following record: \" + recordID);\n} else {\n  gs.print(\"An incident with the specified field value was not found\");\n}\n```\n\nOutput:\n\n```\nAn incident with the specified field value was found\nFound in the following record: 552c48888c033300964f4932b03eb092\n```\n\n## GlideRecord - get\\(Object name, Object value\\)\n\nReturns the specified record in the current GlideRecord object.\n\nThis method accepts either one or two parameters. If only a single parameter is passed in, the method assumes that it is the sys\\_id of the desired record. If not found, it then tries to match the value against the display value. If two parameters are passed in, the first is the name of the column within the GlideRecord to search. The second is the value to search for. If multiple records are found, use next\\(\\) to access the additional records.\n\n|Name|Type|Description|\n|----|----|-----------|\n|name|Object|Optional. Name of the instantiated GlideRecord column to search for the specified **value** parameter. If only a single parameter is passed in, the method assumes that this parameter is sys\\_id.|\n|value|Object|Value to match. For calculated fields, the value is matched as is rather than running a calculation on a scripted default value for a field in the record.|\n\n<table id=\"table_cwp_pcr_dt\" class=\"returns\"><thead><tr><th>\n\nType\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nBoolean\n\n</td><td>\n\nIndicates whether the requested record was located.Possible values:\n\n-   true: Record was found\n-   false: Record was not found\n\n</td></tr></tbody>\n</table>This example gets an incident record by passing in the sys\\_id.\n\n```\nvar grIncident = new GlideRecord('incident');\nvar returnValue = grIncident.get('99ebb4156fa831005be8883e6b3ee4b9');\ngs.info(returnValue); // logs true or false\ngs.info(grIncident.number); // logs Incident Number\n```\n\nThis example gets an incident record by passing in the column in the record to search and the value to search for.\n\n```\nvar grIncident = new GlideRecord('incident');\nvar returnValue = grIncident.get('caller_id.name','Sylivia Wayland');\ngs.info(returnValue); // logs true or false\ngs.info(grIncident.number); // logs Incident Number\n```\n\n### Scoped equivalent\n\nTo use the get\\(\\) method in a scoped application, use the corresponding scoped method: [get\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordScopedAPI.md).\n\n## GlideRecord - getAttribute\\(String fieldName\\)\n\nReturns the dictionary attributes on the specified field.\n\n|Name|Type|Description|\n|----|----|-----------|\n|fieldName|String|Field name for which to return the dictionary attributes|\n\n|Type|Description|\n|----|-----------|\n|String|Dictionary attributes|\n\nThis example shows how to return the dictionary attributes for \"tree\\_picker\".\n\n```\nfunction doit() {\n  var now_GR = new GlideRecord('sys_user');\n  now_GR.query(\"user_name\",\"admin\");\n  if (now_GR.next()) {\n    gs.print(\"we got one\");\n    gs.print(now_GR.location.getAttribute(\"tree_picker\"));\n  }\n}\n```\n\n### Scoped equivalent\n\nTo use the getAttribute\\(\\) method in a scoped application, use the corresponding scoped method: [getAttribute\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordScopedAPI.md).\n\n## GlideRecord - getClassDisplayValue\\(\\)\n\nReturns the table's label.\n\n|Name|Type|Description|\n|----|----|-----------|\n|None| | |\n\n|Type|Description|\n|----|-----------|\n|String|Label that identifies the table.|\n\nThis example prints the label of the passed in table.\n\n```\n// Display the incident table label\nvar now_GR = new GlideRecord(\"incident\");\nvar value = now_GR.getClassDisplayValue();\ngs.info(\"The table label is \" + value + \".\");\n```\n\nOutput:\n\n```\nThe table label is Incident.\n```\n\n### Scoped equivalent\n\nTo use the getClassDisplayValue\\(\\) method in a scoped application, use the corresponding scoped method: [getClassDisplayValue\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordScopedAPI.md).\n\n## GlideRecord - getDisplayValue\\(String name\\)\n\nRetrieves the display value for the current record or the display value of an attribute in a dynamic attribute store.\n\n[Display values](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/platform-administration/c_DisplayValues.md) are manipulated based on the actual value in the database and user or system settings and preferences.\n\nThe display value that is returned is dependent on the field type.\n\n-   Choice fields: The database value may be a number, but the display value is more descriptive.\n-   Date fields: The database value is in UTC format, while the display value is based on the user's time zone.\n-   Encrypted text: The database value is encrypted, while the displayed value is unencrypted based on the user's encryption context.\n-   Reference fields: The database value is sys\\_id, but the display value is the display field of the referenced record.\n\nSee also [Dynamic Schema](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/platform-administration/dynamic-schema.md).\n\n<table id=\"table_kps_f2r_dt\" class=\"parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nType\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nname\n\n</td><td>\n\nString\n\n</td><td>\n\nOptional. Only required when requesting the display value for a dynamic attribute. Path to an attribute within a dynamic schema to retrieve.\n\nFormat of the attribute path: `dyn_att_field->attr_name`\n\n-   `dyn_att_field`: Name of a dynamic attribute store field on the table.\n-   `attr_name`: Name of the dynamic attribute.\n\nTable: Dynamic Attribute \\[dynamic\\_attribute\\]\n\n\nSee also [Dynamic Schema](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/platform-administration/dynamic-schema.md).\n\n</td></tr></tbody>\n</table>|Type|Description|\n|----|-----------|\n|String|Display value for the current record or specified element.|\n\nThis example writes the display value of a specified incident record into the log.\n\n```\nvar now_GR = new GlideRecord('incident');\nnow_GR.get('sys_id','<sys_id>');\ngs.info(now_GR.getDisplayValue());\n```\n\nOutput:\n\n```\nINC0000050\n```\n\nThis example shows how to retrieve the display value of an attribute within a dynamic attribute store element.\n\n```\nvar gr_AppTab = new GlideRecord('application_table'); \ngr_AppTab.setValue('dyn_att_field->attr', 42); \ngr_AppTab.setDisplayValue('dyn_att_field->attr2, true);\ngr_AppTab.update();\ngs.info('Attr value: ' + \ngr_AppTab.getDisplayValue('dyn_att_field->attr);\ngs.info('Attr2 value: ' + \ngr_AppTab.getDisplayValue('dyn_att_field->attr2);\n```\n\nOutput:\n\n```\nAttr value: System error\nAttr2 value: true\n```\n\n### Scoped equivalent\n\nTo use the getDisplayValue\\(\\) method in a scoped application, use the corresponding scoped method: [getDisplayValue\\(\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/c_GlideRecordScopedAPI.md).\n\n## GlideRecord - getDynamicAttribute\\(String fullPath\\)\n\nReturns the GlideElementDynamicAttribute object for the specified dynamic attribute store path.\n\nDynamic attributes have a defined data type and a sys\\_id. For more details on dynamic attributes, see [Dynamic schema](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/platform-administration/dynamic-schema.md).\n\nSee also:\n\n-   [GlideDynamicAttribute - Global](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/GlideDynamicAttributeAPI.md)\n-   [GlideDynamicAttributeStore - Global](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/GlideDynamicAttStoreAPI.md)\n-   [GlideDynamicNamespace - Global](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/GlideDynamicNamespaceAPI.md)\n\n<table id=\"table_rgk_h1x_1bc\" class=\"parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nType\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nfullPath\n\n</td><td>\n\nString\n\n</td><td>\n\nPath to use to locate the desired dynamic attribute. Format of the attribute path: `dyn_att_field->attr_name`\n\n-   `dyn_att_field`: Name of a dynamic attribute store field on the table.\n-   `attr_name`: Name of the dynamic attribute.\n\nTable: Dynamic Attribute \\[dynamic\\_attribute\\]\n\n\nSee also [Dynamic Schema](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/platform-administration/dynamic-schema.md).\n\n</td></tr></tbody>\n</table><table id=\"table_sgk_h1x_1bc\" class=\"returns\"><thead><tr><th>\n\nType\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nObject\n\n</td><td>\n\nGlideElementDynamicAttribute object containing the specified dynamic attribute.If the **fullPath** parameter is invalid, returns null.\n\n</td></tr></tbody>\n</table>The following code example shows how to call this method.\n\n```\nvar gr_Inc = new GlideRecord('incident');\ngr_Inc.get('number', 'INC0009009');\ngr_Inc.getDynamicAttribute('attr_store->color').setValue('Blue');\ngr_Inc.update();\n\ngr_Inc = new GlideRecord('incident');\ngr_Inc.get('number', 'INC0009009');\ngs.info(gr_Inc.getDynamicAttribute('attr_store', 'color'));\n```\n\nOutput:\n\n```\n*** Script: Blue\n```\n\n## GlideRecord - getDynamicAttribute\\(String dynamicAttributeField, String attrPath\\)\n\nReturns a GlideElementDynamicAttribute object that contains the dynamic attribute located at the specified table field and attribute path.\n\nDynamic attributes have a defined data type and a sys\\_id. For more details on dynamic attributes, see [Dynamic schema](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/platform-administration/dynamic-schema.md).\n\nSee also:\n\n-   [GlideDynamicAttribute - Global](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/GlideDynamicAttributeAPI.md)\n-   [GlideDynamicAttributeStore - Global](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/GlideDynamicAttStoreAPI.md)\n-   [GlideDynamicNamespace - Global](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/GlideDynamicNamespaceAPI.md)\n\n<table id=\"table_yzz_p1x_1bc\" class=\"parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nType\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\ndynamicAttributeField\n\n</td><td>\n\nString\n\n</td><td id=\"DynS-dynamicAttributeField-entry\">\n\nName of the field in the table that contains the dynamic attribute.\n\n</td></tr><tr><td>\n\nattrPath\n\n</td><td>\n\nString\n\n</td><td>\n\nAttribute path to use to locate the associated dynamic schema attribute.Format: `\"attr_name\"`\n\n`attr_name`: Name of the dynamic attribute.\n\nTable: In the attribute field of the Dynamic Attribute \\[dynamic\\_attribute\\] table.\n\n</td></tr></tbody>\n</table><table id=\"table_zzz_p1x_1bc\" class=\"returns\"><thead><tr><th>\n\nType\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nObject\n\n</td><td>\n\nGlideElementDynamicAttribute object containing the specified dynamic attribute.If either the **dynamicAttributeField** or **attrPath** parameters are invalid, returns null.\n\n</td></tr></tbody>\n</table>The following code example shows how to call this method.\n\n```\nvar gr_Inc = new GlideRecord('incident');\ngr_Inc.get('number', 'INC0009009');\ngr_Inc.getDynamicAttribute('attr_store', 'color').setValue('Blue');\ngr_Inc.update();\n\ngr_Inc = new GlideRecord('incident');\ngr_Inc.get('number', 'INC0009009');\ngs.info(gr_Inc.getDynamicAttribute('attr_store', 'color'));\n```\n\nOutput:\n\n```\n*** Script: Blue\n```\n\n## GlideRecord - getDynamicAttributeValue\\(String fullPath\\)\n\nReturns the value of the dynamic attribute located at a specified path.\n\nDynamic attributes have a defined data type and a sys\\_id. For more details on dynamic attributes, see [Dynamic schema](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/platform-administration/dynamic-schema.md).\n\nSee also:\n\n-   [GlideDynamicAttribute - Global](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/GlideDynamicAttributeAPI.md)\n-   [GlideDynamicAttributeStore - Global](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/GlideDynamicAttStoreAPI.md)\n-   [GlideDynamicNamespace - Global](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/server-api-reference/GlideDynamicNamespaceAPI.md)\n\n<table id=\"table_oh3_x1x_1bc\" class=\"parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nType\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nfullPath\n\n</td><td>\n\nString\n\n</td><td>\n\nPath to use to locate the desired dynamic attribute. Format of the attribute path: `dyn_att_field->attr_name`\n\n-   `dyn_att_field`: Name of a dynamic attribute store field on the table.\n-   `attr_name`: Name of the dynamic attribute.\n\nTable: Dynamic Attribute \\[dynamic\\_attribute\\]\n\n\nSee also [Dynamic Schema](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/platform-administration/dynamic-schema.md).\n\n</td></tr></tbody>\n</table><table id=\"table_ph3_x1x_1bc\" class=\"returns\"><thead><tr><th>\n\nType\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nObject\n\n</td><td>\n\nValue of the dynamic attribute located at the specified path.If 
[...]
